// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ThGetUrl.pas' rev: 5.00

#ifndef ThGetUrlHPP
#define ThGetUrlHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ThGetThr.hpp>	// Pascal unit
#include <ThCrkUrl.hpp>	// Pascal unit
#include <ThUrlQue.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Thgeturl
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TMFHttpGetState { GETHTTP_NOTUSED, GETHTTP_WAITING, GETHTTP_PREPARING, GETHTTP_GETTING, GETHTTP_THREAD_DONE, 
	GETHTTP_OK, GETHTTP_ERROR };
#pragma option pop

#pragma option push -b-
enum TMFHttpGetRequest { GETHTTP_HEAD, GETHTTP_BODY };
#pragma option pop

typedef void __fastcall (__closure *TOnGetUrlHeadComplete)(System::TObject* Sender, AnsiString Url, 
	AnsiString Head_, int StatusCode, AnsiString ContentType, int ContentLength, int DepthSearchLevel_, 
	bool &OkToGetData, int CountArea);

typedef void __fastcall (__closure *TOnError)(System::TObject* Sender, unsigned ErrorCode, AnsiString 
	ErrorMsg);

typedef void __fastcall (__closure *TOnFileComplete)(System::TObject* Sender, AnsiString FilePath, int 
	ContentLength);

typedef void __fastcall (__closure *TOnDataComplete)(System::TObject* Sender, AnsiString Result);

typedef void __fastcall (__closure *TOnGetUrlLog)(System::TObject* Sender, AnsiString LogMessage);

class DELPHICLASS TMFHttpGet;
class PASCALIMPLEMENTATION TMFHttpGet : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	bool Continue;
	AnsiString FAcceptTypes;
	AnsiString FAgent;
	bool FReuseCache;
	AnsiString FUserName;
	AnsiString FPassword;
	AnsiString FPostQuery;
	AnsiString FReferringUrl;
	bool FWait;
	TOnGetUrlLog FLog;
	Thgetthr::THTTPGetThread* GetThread;
	TOnError FError;
	TMFHttpGetState FState;
	TMFHttpGetRequest FRequest;
	bool FThreadDoneOk;
	bool FThreadABorted;
	int FStatusCode;
	AnsiString FErrorMsg;
	unsigned FContentLength;
	Thgetthr::TOnThreadProgress FOnProgress;
	unsigned FConnectTimeOut;
	int FTimeOut;
	bool FThreadRunning;
	AnsiString FBody;
	AnsiString FHead;
	bool FKilled;
	Thurlque::TGetAction FGetAction;
	Thgetthr::TProxyType FProxyType;
	AnsiString FProxyAddress;
	int FProxyPort;
	AnsiString FProxyUser;
	AnsiString FProxyPassword;
	TOnGetUrlHeadComplete FOnHeadComplete;
	void __fastcall HeadComplete(System::TObject* Sender, AnsiString Head_, int StatusCode_, AnsiString 
		ContentType_, int ContentLength_, bool &OkToGetData);
	void __fastcall Progress(System::TObject* Sender, unsigned BytesRead);
	void __fastcall OnDataComplete(AnsiString &DataString);
	void __fastcall OnStatusCode(int StatusCode_);
	void __fastcall OnEndThread(System::TObject* Sender);
	int __fastcall GetTimeOut(void);
	void __fastcall SetTimeOut(int Value);
	
public:
	Thcrkurl::TCrackUrl* CrackedUrl;
	int DepthSearchLevel;
	int RetryCount;
	int CountArea;
	char HrefOrSrc;
	int ReturnTag;
	__fastcall TMFHttpGet(void);
	__fastcall virtual ~TMFHttpGet(void);
	void __fastcall Get(TMFHttpGetRequest Request_);
	void __fastcall KillGet(void);
	void __fastcall FinalizeGet(void);
	void __fastcall RefreshTimeOut(void);
	__property bool ThreadDoneOk = {read=FThreadDoneOk, nodefault};
	__property bool ThreadAborted = {read=FThreadABorted, nodefault};
	__property bool Killed = {read=FKilled, nodefault};
	__property Thurlque::TGetAction GetAction = {read=FGetAction, write=FGetAction, nodefault};
	__property int TimeOut = {read=GetTimeOut, write=SetTimeOut, nodefault};
	__property unsigned ConnectTimeOut = {read=FConnectTimeOut, write=FConnectTimeOut, nodefault};
	__property AnsiString AcceptTypes = {read=FAcceptTypes, write=FAcceptTypes};
	__property AnsiString Agent = {read=FAgent, write=FAgent};
	__property bool ReuseCache = {read=FReuseCache, write=FReuseCache, nodefault};
	__property AnsiString UserName = {read=FUserName, write=FUserName};
	__property AnsiString Password = {read=FPassword, write=FPassword};
	__property unsigned ContentLength = {read=FContentLength, write=FContentLength, nodefault};
	__property AnsiString PostQuery = {read=FPostQuery, write=FPostQuery};
	__property AnsiString ReferringUrl = {read=FReferringUrl, write=FReferringUrl};
	__property bool Wait = {read=FWait, write=FWait, nodefault};
	__property TMFHttpGetState State = {read=FState, write=FState, nodefault};
	__property TMFHttpGetRequest Request = {read=FRequest, write=FRequest, nodefault};
	__property int StatusCode = {read=FStatusCode, nodefault};
	__property AnsiString Head = {read=FHead};
	__property AnsiString Body = {read=FBody, write=FBody};
	__property AnsiString ErrorMsg = {read=FErrorMsg};
	__property TOnError OnError = {read=FError, write=FError};
	__property TOnGetUrlHeadComplete OnHeadComplete = {read=FOnHeadComplete, write=FOnHeadComplete};
	__property Thgetthr::TProxyType ProxyType = {read=FProxyType, write=FProxyType, nodefault};
	__property AnsiString ProxyAddress = {read=FProxyAddress, write=FProxyAddress};
	__property int ProxyPort = {read=FProxyPort, write=FProxyPort, nodefault};
	__property AnsiString ProxyUser = {read=FProxyUser, write=FProxyUser};
	__property AnsiString ProxyPassword = {read=FProxyPassword, write=FProxyPassword};
	__property TOnGetUrlLog OnLog = {read=FLog, write=FLog};
	__property Thgetthr::TOnThreadProgress OnProgress = {read=FOnProgress, write=FOnProgress};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Thgeturl */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Thgeturl;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ThGetUrl
